from funcionesSimELectrica import *
from funcionesSimFisica import *
from scipy.integrate import cumulative_trapezoid as integrar

import matplotlib.pyplot as plt
import numpy as np


__author__ = 'Oscar Suescun' 

lts_path = "C:/Users/osuescuneli/AppData/Local/Programs/ADI/LTspice/LTspice.exe"

'''
Esto sirve para hacer debug del sistema y ver como se comportan 
las funciones para la 

'''
if __name__ == '__main__':
    tiempoSimulacion = 20e-3
    tiempoSwitch = 1e-6
    tiempoMos = 1e-3

    numeroModulos = 1

    longitudBobina = 53.21e-3 # m
    diametroInteriorBobina = 6.035-3 * 2 # m
    espirasBobina = 800
    diametroCuBobina = 0.8e-3 # m

    longitudVastago = 96e-3 # m
    diametroVastago = 3.045e-3 * 2 # m
        
    Tension = 30 # V
    Capacitancia = 500e-6 # F

    masa = calcular_masa(diametroVastago, longitudVastago)
    anguloDisparo = 40


    resistencia = calcular_resistencia(diametroCuBobina, longitudBobina,
                                       diametroInteriorBobina, espirasBobina)
    
    reluctancia = np.mean(reluctancia_funcX(longitudVastago, diametroVastago,
                                            longitudBobina, diametroInteriorBobina,
                                            diametroCuBobina, espirasBobina))
    
    inductancia = espirasBobina**2 / reluctancia

    resultadosSim = simular(Tension, resistencia,
                            inductancia, Capacitancia, lts_path, 
                            tSim= tiempoSimulacion,
                            toff_sw= tiempoSwitch,
                            ton_mos= tiempoMos)
    
    tiempo = resultadosSim['tiempo'][resultadosSim['tiempo'] >= tiempoMos]

    dt = np.full(len(tiempo), tiempoMos)
    tiempo -= dt

    corriente = resultadosSim['iBob'][resultadosSim['tiempo'] >= tiempoMos]

    fuerzaMag = fuerza_magnetica(corriente, reluctancia, 
                                 espirasBobina, diametroVastago)
    
    aVastago = aceleracion(masa, anguloDisparo, fuerzaMag)
    vVastago = integrar(aVastago, initial=0)
    xVastago = integrar(vVastago, initial=0)

    plt.figure()
    plt.plot(tiempo * 1e3, xVastago)
    plt.grid()
    plt.legend()
    plt.show()